package com.neusoft.smart.pos.ota.persistent.domain;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class UpgradePackageExample {

	protected String orderByClause;

	protected boolean distinct;

	protected List<Criteria> oredCriteria;

	private Integer offset;

	private Integer limit;

	public UpgradePackageExample() {
		oredCriteria = new ArrayList<Criteria>();
	}

	public String getOrderByClause() {
		return orderByClause;
	}

	public void setOrderByClause(String orderByClause) {
		this.orderByClause = orderByClause;
	}

	public boolean isDistinct() {
		return distinct;
	}

	public void setDistinct(boolean distinct) {
		this.distinct = distinct;
	}

	public List<Criteria> getOredCriteria() {
		return oredCriteria;
	}

	public void or(Criteria criteria) {
		oredCriteria.add(criteria);
	}

	public Criteria or() {
		Criteria criteria = createCriteriaInternal();
		oredCriteria.add(criteria);
		return criteria;
	}

	public Criteria createCriteria() {
		Criteria criteria = createCriteriaInternal();
		if (oredCriteria.size() == 0) {
			oredCriteria.add(criteria);
		}
		return criteria;
	}

	protected Criteria createCriteriaInternal() {
		Criteria criteria = new Criteria();
		return criteria;
	}

	public void clear() {
		oredCriteria.clear();
		orderByClause = null;
		distinct = false;
		this.offset = null;
		this.limit = null;
	}

	public Integer getOffset() {
		return this.offset;
	}

	public void setOffset(Integer offset) {
		this.offset = offset;
	}

	public Integer getLimit() {
		return this.limit;
	}

	public void setLimit(Integer limit) {
		this.limit = limit;
	}

	public UpgradePackageExample page(int offset, int limit) {
		this.offset = offset;
		this.limit = limit;
		return this;
	}

	protected abstract static class GeneratedCriteria {

		protected List<Criterion> criteria;

		protected GeneratedCriteria() {
			super();
			criteria = new ArrayList<Criterion>();
		}

		public boolean isValid() {
			return criteria.size() > 0;
		}

		public List<Criterion> getAllCriteria() {
			return criteria;
		}

		public List<Criterion> getCriteria() {
			return criteria;
		}

		protected void addCriterion(String condition) {
			if (condition == null) {
				throw new RuntimeException("Value for condition cannot be null");
			}
			criteria.add(new Criterion(condition));
		}

		protected void addCriterion(String condition, Object value, String property) {
			if (value == null) {
				throw new RuntimeException("Value for " + property + " cannot be null");
			}
			criteria.add(new Criterion(condition, value));
		}

		protected void addCriterion(String condition, Object value1, Object value2, String property) {
			if (value1 == null || value2 == null) {
				throw new RuntimeException("Between values for " + property + " cannot be null");
			}
			criteria.add(new Criterion(condition, value1, value2));
		}

		public Criteria andIdIsNull() {
			addCriterion("id is null");
			return (Criteria) this;
		}

		public Criteria andIdIsNotNull() {
			addCriterion("id is not null");
			return (Criteria) this;
		}

		public Criteria andIdEqualTo(Integer value) {
			addCriterion("id =", value, "id");
			return (Criteria) this;
		}

		public Criteria andIdNotEqualTo(Integer value) {
			addCriterion("id <>", value, "id");
			return (Criteria) this;
		}

		public Criteria andIdGreaterThan(Integer value) {
			addCriterion("id >", value, "id");
			return (Criteria) this;
		}

		public Criteria andIdGreaterThanOrEqualTo(Integer value) {
			addCriterion("id >=", value, "id");
			return (Criteria) this;
		}

		public Criteria andIdLessThan(Integer value) {
			addCriterion("id <", value, "id");
			return (Criteria) this;
		}

		public Criteria andIdLessThanOrEqualTo(Integer value) {
			addCriterion("id <=", value, "id");
			return (Criteria) this;
		}

		public Criteria andIdIn(List<Integer> values) {
			addCriterion("id in", values, "id");
			return (Criteria) this;
		}

		public Criteria andIdNotIn(List<Integer> values) {
			addCriterion("id not in", values, "id");
			return (Criteria) this;
		}

		public Criteria andIdBetween(Integer value1, Integer value2) {
			addCriterion("id between", value1, value2, "id");
			return (Criteria) this;
		}

		public Criteria andIdNotBetween(Integer value1, Integer value2) {
			addCriterion("id not between", value1, value2, "id");
			return (Criteria) this;
		}

		public Criteria andFileNameIsNull() {
			addCriterion("file_name is null");
			return (Criteria) this;
		}

		public Criteria andFileNameIsNotNull() {
			addCriterion("file_name is not null");
			return (Criteria) this;
		}

		public Criteria andFileNameEqualTo(String value) {
			addCriterion("file_name =", value, "fileName");
			return (Criteria) this;
		}

		public Criteria andFileNameNotEqualTo(String value) {
			addCriterion("file_name <>", value, "fileName");
			return (Criteria) this;
		}

		public Criteria andFileNameGreaterThan(String value) {
			addCriterion("file_name >", value, "fileName");
			return (Criteria) this;
		}

		public Criteria andFileNameGreaterThanOrEqualTo(String value) {
			addCriterion("file_name >=", value, "fileName");
			return (Criteria) this;
		}

		public Criteria andFileNameLessThan(String value) {
			addCriterion("file_name <", value, "fileName");
			return (Criteria) this;
		}

		public Criteria andFileNameLessThanOrEqualTo(String value) {
			addCriterion("file_name <=", value, "fileName");
			return (Criteria) this;
		}

		public Criteria andFileNameLike(String value) {
			addCriterion("file_name like", value, "fileName");
			return (Criteria) this;
		}

		public Criteria andFileNameNotLike(String value) {
			addCriterion("file_name not like", value, "fileName");
			return (Criteria) this;
		}

		public Criteria andFileNameIn(List<String> values) {
			addCriterion("file_name in", values, "fileName");
			return (Criteria) this;
		}

		public Criteria andFileNameNotIn(List<String> values) {
			addCriterion("file_name not in", values, "fileName");
			return (Criteria) this;
		}

		public Criteria andFileNameBetween(String value1, String value2) {
			addCriterion("file_name between", value1, value2, "fileName");
			return (Criteria) this;
		}

		public Criteria andFileNameNotBetween(String value1, String value2) {
			addCriterion("file_name not between", value1, value2, "fileName");
			return (Criteria) this;
		}

		public Criteria andFilePathIsNull() {
			addCriterion("file_path is null");
			return (Criteria) this;
		}

		public Criteria andFilePathIsNotNull() {
			addCriterion("file_path is not null");
			return (Criteria) this;
		}

		public Criteria andFilePathEqualTo(String value) {
			addCriterion("file_path =", value, "filePath");
			return (Criteria) this;
		}

		public Criteria andFilePathNotEqualTo(String value) {
			addCriterion("file_path <>", value, "filePath");
			return (Criteria) this;
		}

		public Criteria andFilePathGreaterThan(String value) {
			addCriterion("file_path >", value, "filePath");
			return (Criteria) this;
		}

		public Criteria andFilePathGreaterThanOrEqualTo(String value) {
			addCriterion("file_path >=", value, "filePath");
			return (Criteria) this;
		}

		public Criteria andFilePathLessThan(String value) {
			addCriterion("file_path <", value, "filePath");
			return (Criteria) this;
		}

		public Criteria andFilePathLessThanOrEqualTo(String value) {
			addCriterion("file_path <=", value, "filePath");
			return (Criteria) this;
		}

		public Criteria andFilePathLike(String value) {
			addCriterion("file_path like", value, "filePath");
			return (Criteria) this;
		}

		public Criteria andFilePathNotLike(String value) {
			addCriterion("file_path not like", value, "filePath");
			return (Criteria) this;
		}

		public Criteria andFilePathIn(List<String> values) {
			addCriterion("file_path in", values, "filePath");
			return (Criteria) this;
		}

		public Criteria andFilePathNotIn(List<String> values) {
			addCriterion("file_path not in", values, "filePath");
			return (Criteria) this;
		}

		public Criteria andFilePathBetween(String value1, String value2) {
			addCriterion("file_path between", value1, value2, "filePath");
			return (Criteria) this;
		}

		public Criteria andFilePathNotBetween(String value1, String value2) {
			addCriterion("file_path not between", value1, value2, "filePath");
			return (Criteria) this;
		}

		public Criteria andFileSizeIsNull() {
			addCriterion("file_size is null");
			return (Criteria) this;
		}

		public Criteria andFileSizeIsNotNull() {
			addCriterion("file_size is not null");
			return (Criteria) this;
		}

		public Criteria andFileSizeEqualTo(Integer value) {
			addCriterion("file_size =", value, "fileSize");
			return (Criteria) this;
		}

		public Criteria andFileSizeNotEqualTo(Integer value) {
			addCriterion("file_size <>", value, "fileSize");
			return (Criteria) this;
		}

		public Criteria andFileSizeGreaterThan(Integer value) {
			addCriterion("file_size >", value, "fileSize");
			return (Criteria) this;
		}

		public Criteria andFileSizeGreaterThanOrEqualTo(Integer value) {
			addCriterion("file_size >=", value, "fileSize");
			return (Criteria) this;
		}

		public Criteria andFileSizeLessThan(Integer value) {
			addCriterion("file_size <", value, "fileSize");
			return (Criteria) this;
		}

		public Criteria andFileSizeLessThanOrEqualTo(Integer value) {
			addCriterion("file_size <=", value, "fileSize");
			return (Criteria) this;
		}

		public Criteria andFileSizeIn(List<Integer> values) {
			addCriterion("file_size in", values, "fileSize");
			return (Criteria) this;
		}

		public Criteria andFileSizeNotIn(List<Integer> values) {
			addCriterion("file_size not in", values, "fileSize");
			return (Criteria) this;
		}

		public Criteria andFileSizeBetween(Integer value1, Integer value2) {
			addCriterion("file_size between", value1, value2, "fileSize");
			return (Criteria) this;
		}

		public Criteria andFileSizeNotBetween(Integer value1, Integer value2) {
			addCriterion("file_size not between", value1, value2, "fileSize");
			return (Criteria) this;
		}

		public Criteria andMd5CodeIsNull() {
			addCriterion("md5_code is null");
			return (Criteria) this;
		}

		public Criteria andMd5CodeIsNotNull() {
			addCriterion("md5_code is not null");
			return (Criteria) this;
		}

		public Criteria andMd5CodeEqualTo(String value) {
			addCriterion("md5_code =", value, "md5Code");
			return (Criteria) this;
		}

		public Criteria andMd5CodeNotEqualTo(String value) {
			addCriterion("md5_code <>", value, "md5Code");
			return (Criteria) this;
		}

		public Criteria andMd5CodeGreaterThan(String value) {
			addCriterion("md5_code >", value, "md5Code");
			return (Criteria) this;
		}

		public Criteria andMd5CodeGreaterThanOrEqualTo(String value) {
			addCriterion("md5_code >=", value, "md5Code");
			return (Criteria) this;
		}

		public Criteria andMd5CodeLessThan(String value) {
			addCriterion("md5_code <", value, "md5Code");
			return (Criteria) this;
		}

		public Criteria andMd5CodeLessThanOrEqualTo(String value) {
			addCriterion("md5_code <=", value, "md5Code");
			return (Criteria) this;
		}

		public Criteria andMd5CodeLike(String value) {
			addCriterion("md5_code like", value, "md5Code");
			return (Criteria) this;
		}

		public Criteria andMd5CodeNotLike(String value) {
			addCriterion("md5_code not like", value, "md5Code");
			return (Criteria) this;
		}

		public Criteria andMd5CodeIn(List<String> values) {
			addCriterion("md5_code in", values, "md5Code");
			return (Criteria) this;
		}

		public Criteria andMd5CodeNotIn(List<String> values) {
			addCriterion("md5_code not in", values, "md5Code");
			return (Criteria) this;
		}

		public Criteria andMd5CodeBetween(String value1, String value2) {
			addCriterion("md5_code between", value1, value2, "md5Code");
			return (Criteria) this;
		}

		public Criteria andMd5CodeNotBetween(String value1, String value2) {
			addCriterion("md5_code not between", value1, value2, "md5Code");
			return (Criteria) this;
		}

		public Criteria andFileTypeIsNull() {
			addCriterion("file_type is null");
			return (Criteria) this;
		}

		public Criteria andFileTypeIsNotNull() {
			addCriterion("file_type is not null");
			return (Criteria) this;
		}

		public Criteria andFileTypeEqualTo(Integer value) {
			addCriterion("file_type =", value, "fileType");
			return (Criteria) this;
		}

		public Criteria andFileTypeNotEqualTo(Integer value) {
			addCriterion("file_type <>", value, "fileType");
			return (Criteria) this;
		}

		public Criteria andFileTypeGreaterThan(Integer value) {
			addCriterion("file_type >", value, "fileType");
			return (Criteria) this;
		}

		public Criteria andFileTypeGreaterThanOrEqualTo(Integer value) {
			addCriterion("file_type >=", value, "fileType");
			return (Criteria) this;
		}

		public Criteria andFileTypeLessThan(Integer value) {
			addCriterion("file_type <", value, "fileType");
			return (Criteria) this;
		}

		public Criteria andFileTypeLessThanOrEqualTo(Integer value) {
			addCriterion("file_type <=", value, "fileType");
			return (Criteria) this;
		}

		public Criteria andFileTypeIn(List<Integer> values) {
			addCriterion("file_type in", values, "fileType");
			return (Criteria) this;
		}

		public Criteria andFileTypeNotIn(List<Integer> values) {
			addCriterion("file_type not in", values, "fileType");
			return (Criteria) this;
		}

		public Criteria andFileTypeBetween(Integer value1, Integer value2) {
			addCriterion("file_type between", value1, value2, "fileType");
			return (Criteria) this;
		}

		public Criteria andFileTypeNotBetween(Integer value1, Integer value2) {
			addCriterion("file_type not between", value1, value2, "fileType");
			return (Criteria) this;
		}

		public Criteria andVersionCodeIsNull() {
			addCriterion("version_code is null");
			return (Criteria) this;
		}

		public Criteria andVersionCodeIsNotNull() {
			addCriterion("version_code is not null");
			return (Criteria) this;
		}

		public Criteria andVersionCodeEqualTo(String value) {
			addCriterion("version_code =", value, "versionCode");
			return (Criteria) this;
		}

		public Criteria andVersionCodeNotEqualTo(String value) {
			addCriterion("version_code <>", value, "versionCode");
			return (Criteria) this;
		}

		public Criteria andVersionCodeGreaterThan(String value) {
			addCriterion("version_code >", value, "versionCode");
			return (Criteria) this;
		}

		public Criteria andVersionCodeGreaterThanOrEqualTo(String value) {
			addCriterion("version_code >=", value, "versionCode");
			return (Criteria) this;
		}

		public Criteria andVersionCodeLessThan(String value) {
			addCriterion("version_code <", value, "versionCode");
			return (Criteria) this;
		}

		public Criteria andVersionCodeLessThanOrEqualTo(String value) {
			addCriterion("version_code <=", value, "versionCode");
			return (Criteria) this;
		}

		public Criteria andVersionCodeLike(String value) {
			addCriterion("version_code like", value, "versionCode");
			return (Criteria) this;
		}

		public Criteria andVersionCodeNotLike(String value) {
			addCriterion("version_code not like", value, "versionCode");
			return (Criteria) this;
		}

		public Criteria andVersionCodeIn(List<String> values) {
			addCriterion("version_code in", values, "versionCode");
			return (Criteria) this;
		}

		public Criteria andVersionCodeNotIn(List<String> values) {
			addCriterion("version_code not in", values, "versionCode");
			return (Criteria) this;
		}

		public Criteria andVersionCodeBetween(String value1, String value2) {
			addCriterion("version_code between", value1, value2, "versionCode");
			return (Criteria) this;
		}

		public Criteria andVersionCodeNotBetween(String value1, String value2) {
			addCriterion("version_code not between", value1, value2, "versionCode");
			return (Criteria) this;
		}

		public Criteria andPrevPackageIdIsNull() {
			addCriterion("prev_package_id is null");
			return (Criteria) this;
		}

		public Criteria andPrevPackageIdIsNotNull() {
			addCriterion("prev_package_id is not null");
			return (Criteria) this;
		}

		public Criteria andPrevPackageIdEqualTo(Integer value) {
			addCriterion("prev_package_id =", value, "prevPackageId");
			return (Criteria) this;
		}

		public Criteria andPrevPackageIdNotEqualTo(Integer value) {
			addCriterion("prev_package_id <>", value, "prevPackageId");
			return (Criteria) this;
		}

		public Criteria andPrevPackageIdGreaterThan(Integer value) {
			addCriterion("prev_package_id >", value, "prevPackageId");
			return (Criteria) this;
		}

		public Criteria andPrevPackageIdGreaterThanOrEqualTo(Integer value) {
			addCriterion("prev_package_id >=", value, "prevPackageId");
			return (Criteria) this;
		}

		public Criteria andPrevPackageIdLessThan(Integer value) {
			addCriterion("prev_package_id <", value, "prevPackageId");
			return (Criteria) this;
		}

		public Criteria andPrevPackageIdLessThanOrEqualTo(Integer value) {
			addCriterion("prev_package_id <=", value, "prevPackageId");
			return (Criteria) this;
		}

		public Criteria andPrevPackageIdIn(List<Integer> values) {
			addCriterion("prev_package_id in", values, "prevPackageId");
			return (Criteria) this;
		}

		public Criteria andPrevPackageIdNotIn(List<Integer> values) {
			addCriterion("prev_package_id not in", values, "prevPackageId");
			return (Criteria) this;
		}

		public Criteria andPrevPackageIdBetween(Integer value1, Integer value2) {
			addCriterion("prev_package_id between", value1, value2, "prevPackageId");
			return (Criteria) this;
		}

		public Criteria andPrevPackageIdNotBetween(Integer value1, Integer value2) {
			addCriterion("prev_package_id not between", value1, value2, "prevPackageId");
			return (Criteria) this;
		}

		public Criteria andManufacturerIsNull() {
			addCriterion("manufacturer is null");
			return (Criteria) this;
		}

		public Criteria andManufacturerIsNotNull() {
			addCriterion("manufacturer is not null");
			return (Criteria) this;
		}

		public Criteria andManufacturerEqualTo(String value) {
			addCriterion("manufacturer =", value, "manufacturer");
			return (Criteria) this;
		}

		public Criteria andManufacturerNotEqualTo(String value) {
			addCriterion("manufacturer <>", value, "manufacturer");
			return (Criteria) this;
		}

		public Criteria andManufacturerGreaterThan(String value) {
			addCriterion("manufacturer >", value, "manufacturer");
			return (Criteria) this;
		}

		public Criteria andManufacturerGreaterThanOrEqualTo(String value) {
			addCriterion("manufacturer >=", value, "manufacturer");
			return (Criteria) this;
		}

		public Criteria andManufacturerLessThan(String value) {
			addCriterion("manufacturer <", value, "manufacturer");
			return (Criteria) this;
		}

		public Criteria andManufacturerLessThanOrEqualTo(String value) {
			addCriterion("manufacturer <=", value, "manufacturer");
			return (Criteria) this;
		}

		public Criteria andManufacturerLike(String value) {
			addCriterion("manufacturer like", value, "manufacturer");
			return (Criteria) this;
		}

		public Criteria andManufacturerNotLike(String value) {
			addCriterion("manufacturer not like", value, "manufacturer");
			return (Criteria) this;
		}

		public Criteria andManufacturerIn(List<String> values) {
			addCriterion("manufacturer in", values, "manufacturer");
			return (Criteria) this;
		}

		public Criteria andManufacturerNotIn(List<String> values) {
			addCriterion("manufacturer not in", values, "manufacturer");
			return (Criteria) this;
		}

		public Criteria andManufacturerBetween(String value1, String value2) {
			addCriterion("manufacturer between", value1, value2, "manufacturer");
			return (Criteria) this;
		}

		public Criteria andManufacturerNotBetween(String value1, String value2) {
			addCriterion("manufacturer not between", value1, value2, "manufacturer");
			return (Criteria) this;
		}

		public Criteria andDeviceTypeIsNull() {
			addCriterion("device_type is null");
			return (Criteria) this;
		}

		public Criteria andDeviceTypeIsNotNull() {
			addCriterion("device_type is not null");
			return (Criteria) this;
		}

		public Criteria andDeviceTypeEqualTo(String value) {
			addCriterion("device_type =", value, "deviceType");
			return (Criteria) this;
		}

		public Criteria andDeviceTypeNotEqualTo(String value) {
			addCriterion("device_type <>", value, "deviceType");
			return (Criteria) this;
		}

		public Criteria andDeviceTypeGreaterThan(String value) {
			addCriterion("device_type >", value, "deviceType");
			return (Criteria) this;
		}

		public Criteria andDeviceTypeGreaterThanOrEqualTo(String value) {
			addCriterion("device_type >=", value, "deviceType");
			return (Criteria) this;
		}

		public Criteria andDeviceTypeLessThan(String value) {
			addCriterion("device_type <", value, "deviceType");
			return (Criteria) this;
		}

		public Criteria andDeviceTypeLessThanOrEqualTo(String value) {
			addCriterion("device_type <=", value, "deviceType");
			return (Criteria) this;
		}

		public Criteria andDeviceTypeLike(String value) {
			addCriterion("device_type like", value, "deviceType");
			return (Criteria) this;
		}

		public Criteria andDeviceTypeNotLike(String value) {
			addCriterion("device_type not like", value, "deviceType");
			return (Criteria) this;
		}

		public Criteria andDeviceTypeIn(List<String> values) {
			addCriterion("device_type in", values, "deviceType");
			return (Criteria) this;
		}

		public Criteria andDeviceTypeNotIn(List<String> values) {
			addCriterion("device_type not in", values, "deviceType");
			return (Criteria) this;
		}

		public Criteria andDeviceTypeBetween(String value1, String value2) {
			addCriterion("device_type between", value1, value2, "deviceType");
			return (Criteria) this;
		}

		public Criteria andDeviceTypeNotBetween(String value1, String value2) {
			addCriterion("device_type not between", value1, value2, "deviceType");
			return (Criteria) this;
		}

		public Criteria andDeviceModelIsNull() {
			addCriterion("device_model is null");
			return (Criteria) this;
		}

		public Criteria andDeviceModelIsNotNull() {
			addCriterion("device_model is not null");
			return (Criteria) this;
		}

		public Criteria andDeviceModelEqualTo(String value) {
			addCriterion("device_model =", value, "deviceModel");
			return (Criteria) this;
		}

		public Criteria andDeviceModelNotEqualTo(String value) {
			addCriterion("device_model <>", value, "deviceModel");
			return (Criteria) this;
		}

		public Criteria andDeviceModelGreaterThan(String value) {
			addCriterion("device_model >", value, "deviceModel");
			return (Criteria) this;
		}

		public Criteria andDeviceModelGreaterThanOrEqualTo(String value) {
			addCriterion("device_model >=", value, "deviceModel");
			return (Criteria) this;
		}

		public Criteria andDeviceModelLessThan(String value) {
			addCriterion("device_model <", value, "deviceModel");
			return (Criteria) this;
		}

		public Criteria andDeviceModelLessThanOrEqualTo(String value) {
			addCriterion("device_model <=", value, "deviceModel");
			return (Criteria) this;
		}

		public Criteria andDeviceModelLike(String value) {
			addCriterion("device_model like", value, "deviceModel");
			return (Criteria) this;
		}

		public Criteria andDeviceModelNotLike(String value) {
			addCriterion("device_model not like", value, "deviceModel");
			return (Criteria) this;
		}

		public Criteria andDeviceModelIn(List<String> values) {
			addCriterion("device_model in", values, "deviceModel");
			return (Criteria) this;
		}

		public Criteria andDeviceModelNotIn(List<String> values) {
			addCriterion("device_model not in", values, "deviceModel");
			return (Criteria) this;
		}

		public Criteria andDeviceModelBetween(String value1, String value2) {
			addCriterion("device_model between", value1, value2, "deviceModel");
			return (Criteria) this;
		}

		public Criteria andDeviceModelNotBetween(String value1, String value2) {
			addCriterion("device_model not between", value1, value2, "deviceModel");
			return (Criteria) this;
		}

		public Criteria andCustomerIsNull() {
			addCriterion("customer is null");
			return (Criteria) this;
		}

		public Criteria andCustomerIsNotNull() {
			addCriterion("customer is not null");
			return (Criteria) this;
		}

		public Criteria andCustomerEqualTo(String value) {
			addCriterion("customer =", value, "customer");
			return (Criteria) this;
		}

		public Criteria andCustomerNotEqualTo(String value) {
			addCriterion("customer <>", value, "customer");
			return (Criteria) this;
		}

		public Criteria andCustomerGreaterThan(String value) {
			addCriterion("customer >", value, "customer");
			return (Criteria) this;
		}

		public Criteria andCustomerGreaterThanOrEqualTo(String value) {
			addCriterion("customer >=", value, "customer");
			return (Criteria) this;
		}

		public Criteria andCustomerLessThan(String value) {
			addCriterion("customer <", value, "customer");
			return (Criteria) this;
		}

		public Criteria andCustomerLessThanOrEqualTo(String value) {
			addCriterion("customer <=", value, "customer");
			return (Criteria) this;
		}

		public Criteria andCustomerLike(String value) {
			addCriterion("customer like", value, "customer");
			return (Criteria) this;
		}

		public Criteria andCustomerNotLike(String value) {
			addCriterion("customer not like", value, "customer");
			return (Criteria) this;
		}

		public Criteria andCustomerIn(List<String> values) {
			addCriterion("customer in", values, "customer");
			return (Criteria) this;
		}

		public Criteria andCustomerNotIn(List<String> values) {
			addCriterion("customer not in", values, "customer");
			return (Criteria) this;
		}

		public Criteria andCustomerBetween(String value1, String value2) {
			addCriterion("customer between", value1, value2, "customer");
			return (Criteria) this;
		}

		public Criteria andCustomerNotBetween(String value1, String value2) {
			addCriterion("customer not between", value1, value2, "customer");
			return (Criteria) this;
		}

		public Criteria andCreatedByIsNull() {
			addCriterion("created_by is null");
			return (Criteria) this;
		}

		public Criteria andCreatedByIsNotNull() {
			addCriterion("created_by is not null");
			return (Criteria) this;
		}

		public Criteria andCreatedByEqualTo(Integer value) {
			addCriterion("created_by =", value, "createdBy");
			return (Criteria) this;
		}

		public Criteria andCreatedByNotEqualTo(Integer value) {
			addCriterion("created_by <>", value, "createdBy");
			return (Criteria) this;
		}

		public Criteria andCreatedByGreaterThan(Integer value) {
			addCriterion("created_by >", value, "createdBy");
			return (Criteria) this;
		}

		public Criteria andCreatedByGreaterThanOrEqualTo(Integer value) {
			addCriterion("created_by >=", value, "createdBy");
			return (Criteria) this;
		}

		public Criteria andCreatedByLessThan(Integer value) {
			addCriterion("created_by <", value, "createdBy");
			return (Criteria) this;
		}

		public Criteria andCreatedByLessThanOrEqualTo(Integer value) {
			addCriterion("created_by <=", value, "createdBy");
			return (Criteria) this;
		}

		public Criteria andCreatedByIn(List<Integer> values) {
			addCriterion("created_by in", values, "createdBy");
			return (Criteria) this;
		}

		public Criteria andCreatedByNotIn(List<Integer> values) {
			addCriterion("created_by not in", values, "createdBy");
			return (Criteria) this;
		}

		public Criteria andCreatedByBetween(Integer value1, Integer value2) {
			addCriterion("created_by between", value1, value2, "createdBy");
			return (Criteria) this;
		}

		public Criteria andCreatedByNotBetween(Integer value1, Integer value2) {
			addCriterion("created_by not between", value1, value2, "createdBy");
			return (Criteria) this;
		}

		public Criteria andCreatedDateIsNull() {
			addCriterion("created_date is null");
			return (Criteria) this;
		}

		public Criteria andCreatedDateIsNotNull() {
			addCriterion("created_date is not null");
			return (Criteria) this;
		}

		public Criteria andCreatedDateEqualTo(Date value) {
			addCriterion("created_date =", value, "createdDate");
			return (Criteria) this;
		}

		public Criteria andCreatedDateNotEqualTo(Date value) {
			addCriterion("created_date <>", value, "createdDate");
			return (Criteria) this;
		}

		public Criteria andCreatedDateGreaterThan(Date value) {
			addCriterion("created_date >", value, "createdDate");
			return (Criteria) this;
		}

		public Criteria andCreatedDateGreaterThanOrEqualTo(Date value) {
			addCriterion("created_date >=", value, "createdDate");
			return (Criteria) this;
		}

		public Criteria andCreatedDateLessThan(Date value) {
			addCriterion("created_date <", value, "createdDate");
			return (Criteria) this;
		}

		public Criteria andCreatedDateLessThanOrEqualTo(Date value) {
			addCriterion("created_date <=", value, "createdDate");
			return (Criteria) this;
		}

		public Criteria andCreatedDateIn(List<Date> values) {
			addCriterion("created_date in", values, "createdDate");
			return (Criteria) this;
		}

		public Criteria andCreatedDateNotIn(List<Date> values) {
			addCriterion("created_date not in", values, "createdDate");
			return (Criteria) this;
		}

		public Criteria andCreatedDateBetween(Date value1, Date value2) {
			addCriterion("created_date between", value1, value2, "createdDate");
			return (Criteria) this;
		}

		public Criteria andCreatedDateNotBetween(Date value1, Date value2) {
			addCriterion("created_date not between", value1, value2, "createdDate");
			return (Criteria) this;
		}

		public Criteria andLastModifiedByIsNull() {
			addCriterion("last_modified_by is null");
			return (Criteria) this;
		}

		public Criteria andLastModifiedByIsNotNull() {
			addCriterion("last_modified_by is not null");
			return (Criteria) this;
		}

		public Criteria andLastModifiedByEqualTo(Integer value) {
			addCriterion("last_modified_by =", value, "lastModifiedBy");
			return (Criteria) this;
		}

		public Criteria andLastModifiedByNotEqualTo(Integer value) {
			addCriterion("last_modified_by <>", value, "lastModifiedBy");
			return (Criteria) this;
		}

		public Criteria andLastModifiedByGreaterThan(Integer value) {
			addCriterion("last_modified_by >", value, "lastModifiedBy");
			return (Criteria) this;
		}

		public Criteria andLastModifiedByGreaterThanOrEqualTo(Integer value) {
			addCriterion("last_modified_by >=", value, "lastModifiedBy");
			return (Criteria) this;
		}

		public Criteria andLastModifiedByLessThan(Integer value) {
			addCriterion("last_modified_by <", value, "lastModifiedBy");
			return (Criteria) this;
		}

		public Criteria andLastModifiedByLessThanOrEqualTo(Integer value) {
			addCriterion("last_modified_by <=", value, "lastModifiedBy");
			return (Criteria) this;
		}

		public Criteria andLastModifiedByIn(List<Integer> values) {
			addCriterion("last_modified_by in", values, "lastModifiedBy");
			return (Criteria) this;
		}

		public Criteria andLastModifiedByNotIn(List<Integer> values) {
			addCriterion("last_modified_by not in", values, "lastModifiedBy");
			return (Criteria) this;
		}

		public Criteria andLastModifiedByBetween(Integer value1, Integer value2) {
			addCriterion("last_modified_by between", value1, value2, "lastModifiedBy");
			return (Criteria) this;
		}

		public Criteria andLastModifiedByNotBetween(Integer value1, Integer value2) {
			addCriterion("last_modified_by not between", value1, value2, "lastModifiedBy");
			return (Criteria) this;
		}

		public Criteria andLastModifiedDateIsNull() {
			addCriterion("last_modified_date is null");
			return (Criteria) this;
		}

		public Criteria andLastModifiedDateIsNotNull() {
			addCriterion("last_modified_date is not null");
			return (Criteria) this;
		}

		public Criteria andLastModifiedDateEqualTo(Date value) {
			addCriterion("last_modified_date =", value, "lastModifiedDate");
			return (Criteria) this;
		}

		public Criteria andLastModifiedDateNotEqualTo(Date value) {
			addCriterion("last_modified_date <>", value, "lastModifiedDate");
			return (Criteria) this;
		}

		public Criteria andLastModifiedDateGreaterThan(Date value) {
			addCriterion("last_modified_date >", value, "lastModifiedDate");
			return (Criteria) this;
		}

		public Criteria andLastModifiedDateGreaterThanOrEqualTo(Date value) {
			addCriterion("last_modified_date >=", value, "lastModifiedDate");
			return (Criteria) this;
		}

		public Criteria andLastModifiedDateLessThan(Date value) {
			addCriterion("last_modified_date <", value, "lastModifiedDate");
			return (Criteria) this;
		}

		public Criteria andLastModifiedDateLessThanOrEqualTo(Date value) {
			addCriterion("last_modified_date <=", value, "lastModifiedDate");
			return (Criteria) this;
		}

		public Criteria andLastModifiedDateIn(List<Date> values) {
			addCriterion("last_modified_date in", values, "lastModifiedDate");
			return (Criteria) this;
		}

		public Criteria andLastModifiedDateNotIn(List<Date> values) {
			addCriterion("last_modified_date not in", values, "lastModifiedDate");
			return (Criteria) this;
		}

		public Criteria andLastModifiedDateBetween(Date value1, Date value2) {
			addCriterion("last_modified_date between", value1, value2, "lastModifiedDate");
			return (Criteria) this;
		}

		public Criteria andLastModifiedDateNotBetween(Date value1, Date value2) {
			addCriterion("last_modified_date not between", value1, value2, "lastModifiedDate");
			return (Criteria) this;
		}

		public Criteria andStatusIsNull() {
			addCriterion("status is null");
			return (Criteria) this;
		}

		public Criteria andStatusIsNotNull() {
			addCriterion("status is not null");
			return (Criteria) this;
		}

		public Criteria andStatusEqualTo(Integer value) {
			addCriterion("status =", value, "status");
			return (Criteria) this;
		}

		public Criteria andStatusNotEqualTo(Integer value) {
			addCriterion("status <>", value, "status");
			return (Criteria) this;
		}

		public Criteria andStatusGreaterThan(Integer value) {
			addCriterion("status >", value, "status");
			return (Criteria) this;
		}

		public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
			addCriterion("status >=", value, "status");
			return (Criteria) this;
		}

		public Criteria andStatusLessThan(Integer value) {
			addCriterion("status <", value, "status");
			return (Criteria) this;
		}

		public Criteria andStatusLessThanOrEqualTo(Integer value) {
			addCriterion("status <=", value, "status");
			return (Criteria) this;
		}

		public Criteria andStatusIn(List<Integer> values) {
			addCriterion("status in", values, "status");
			return (Criteria) this;
		}

		public Criteria andStatusNotIn(List<Integer> values) {
			addCriterion("status not in", values, "status");
			return (Criteria) this;
		}

		public Criteria andStatusBetween(Integer value1, Integer value2) {
			addCriterion("status between", value1, value2, "status");
			return (Criteria) this;
		}

		public Criteria andStatusNotBetween(Integer value1, Integer value2) {
			addCriterion("status not between", value1, value2, "status");
			return (Criteria) this;
		}

		public Criteria andReleaseNoteIsNull() {
			addCriterion("release_note is null");
			return (Criteria) this;
		}

		public Criteria andReleaseNoteIsNotNull() {
			addCriterion("release_note is not null");
			return (Criteria) this;
		}

		public Criteria andReleaseNoteEqualTo(String value) {
			addCriterion("release_note =", value, "releaseNote");
			return (Criteria) this;
		}

		public Criteria andReleaseNoteNotEqualTo(String value) {
			addCriterion("release_note <>", value, "releaseNote");
			return (Criteria) this;
		}

		public Criteria andReleaseNoteGreaterThan(String value) {
			addCriterion("release_note >", value, "releaseNote");
			return (Criteria) this;
		}

		public Criteria andReleaseNoteGreaterThanOrEqualTo(String value) {
			addCriterion("release_note >=", value, "releaseNote");
			return (Criteria) this;
		}

		public Criteria andReleaseNoteLessThan(String value) {
			addCriterion("release_note <", value, "releaseNote");
			return (Criteria) this;
		}

		public Criteria andReleaseNoteLessThanOrEqualTo(String value) {
			addCriterion("release_note <=", value, "releaseNote");
			return (Criteria) this;
		}

		public Criteria andReleaseNoteLike(String value) {
			addCriterion("release_note like", value, "releaseNote");
			return (Criteria) this;
		}

		public Criteria andReleaseNoteNotLike(String value) {
			addCriterion("release_note not like", value, "releaseNote");
			return (Criteria) this;
		}

		public Criteria andReleaseNoteIn(List<String> values) {
			addCriterion("release_note in", values, "releaseNote");
			return (Criteria) this;
		}

		public Criteria andReleaseNoteNotIn(List<String> values) {
			addCriterion("release_note not in", values, "releaseNote");
			return (Criteria) this;
		}

		public Criteria andReleaseNoteBetween(String value1, String value2) {
			addCriterion("release_note between", value1, value2, "releaseNote");
			return (Criteria) this;
		}

		public Criteria andReleaseNoteNotBetween(String value1, String value2) {
			addCriterion("release_note not between", value1, value2, "releaseNote");
			return (Criteria) this;
		}

		public Criteria andOrganizationIdIsNull() {
			addCriterion("organization_id is null");
			return (Criteria) this;
		}

		public Criteria andOrganizationIdIsNotNull() {
			addCriterion("organization_id is not null");
			return (Criteria) this;
		}

		public Criteria andOrganizationIdEqualTo(Integer value) {
			addCriterion("organization_id =", value, "organizationId");
			return (Criteria) this;
		}

		public Criteria andOrganizationIdNotEqualTo(Integer value) {
			addCriterion("organization_id <>", value, "organizationId");
			return (Criteria) this;
		}

		public Criteria andOrganizationIdGreaterThan(Integer value) {
			addCriterion("organization_id >", value, "organizationId");
			return (Criteria) this;
		}

		public Criteria andOrganizationIdGreaterThanOrEqualTo(Integer value) {
			addCriterion("organization_id >=", value, "organizationId");
			return (Criteria) this;
		}

		public Criteria andOrganizationIdLessThan(Integer value) {
			addCriterion("organization_id <", value, "organizationId");
			return (Criteria) this;
		}

		public Criteria andOrganizationIdLessThanOrEqualTo(Integer value) {
			addCriterion("organization_id <=", value, "organizationId");
			return (Criteria) this;
		}

		public Criteria andOrganizationIdIn(List<Integer> values) {
			addCriterion("organization_id in", values, "organizationId");
			return (Criteria) this;
		}

		public Criteria andOrganizationIdNotIn(List<Integer> values) {
			addCriterion("organization_id not in", values, "organizationId");
			return (Criteria) this;
		}

		public Criteria andOrganizationIdBetween(Integer value1, Integer value2) {
			addCriterion("organization_id between", value1, value2, "organizationId");
			return (Criteria) this;
		}

		public Criteria andOrganizationIdNotBetween(Integer value1, Integer value2) {
			addCriterion("organization_id not between", value1, value2, "organizationId");
			return (Criteria) this;
		}
	}

	public static class Criteria extends GeneratedCriteria {

		protected Criteria() {
			super();
		}
	}

	public static class Criterion {

		private String condition;

		private Object value;

		private Object secondValue;

		private boolean noValue;

		private boolean singleValue;

		private boolean betweenValue;

		private boolean listValue;

		private String typeHandler;

		protected Criterion(String condition) {
			super();
			this.condition = condition;
			this.typeHandler = null;
			this.noValue = true;
		}

		protected Criterion(String condition, Object value, String typeHandler) {
			super();
			this.condition = condition;
			this.value = value;
			this.typeHandler = typeHandler;
			if (value instanceof List<?>) {
				this.listValue = true;
			} else {
				this.singleValue = true;
			}
		}

		protected Criterion(String condition, Object value) {
			this(condition, value, null);
		}

		protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
			super();
			this.condition = condition;
			this.value = value;
			this.secondValue = secondValue;
			this.typeHandler = typeHandler;
			this.betweenValue = true;
		}

		protected Criterion(String condition, Object value, Object secondValue) {
			this(condition, value, secondValue, null);
		}

		public String getCondition() {
			return condition;
		}

		public Object getValue() {
			return value;
		}

		public Object getSecondValue() {
			return secondValue;
		}

		public boolean isNoValue() {
			return noValue;
		}

		public boolean isSingleValue() {
			return singleValue;
		}

		public boolean isBetweenValue() {
			return betweenValue;
		}

		public boolean isListValue() {
			return listValue;
		}

		public String getTypeHandler() {
			return typeHandler;
		}
	}
}